////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  "   API"
//  * Details   : http://alexander-bagel.blogspot.ru/2013/01/intercept.html
//  * Unit Name : uIAT
//  * Purpose   :     "   "
//  * Author    :  (Rouse_) 
//  * Version   : 1.0.1
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//

unit uIAT;

interface

uses
  Windows, Classes, Controls, Forms, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  DeclaredTypes;

function ReplaceIATEntry(const OldProc, NewProc: FARPROC): Boolean;
var
  ImportEntry: PImageImportDescriptor;
  Thunk: PImageThunkData;
  Protect: DWORD;
  ImageBase: Cardinal;
  DOSHeader: PImageDosHeader;
  NTHeader: PImageNtHeaders;
begin
  Result := False;
  if OldProc = nil then Exit;
  if NewProc = nil then Exit;
  ImageBase := GetModuleHandle(nil);

  //    
  DOSHeader := PImageDosHeader(ImageBase);
  NTHeader := PImageNtHeaders(DWORD(DOSHeader) + DWORD(DOSHeader^._lfanew));
  ImportEntry := PImageImportDescriptor(DWORD(ImageBase) +
      DWORD(NTHeader^.OptionalHeader.DataDirectory[
      IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress));

  //     ...
  while ImportEntry^.Name <> 0 do
  begin
    Thunk := PImageThunkData(DWORD(ImageBase) +
      DWORD(ImportEntry^.FirstThunk));
    // ...     ...
    while Pointer(Thunk^._function) <> nil do
    begin
      // ...      .
      if Pointer(Thunk^._function) = OldProc then
      begin
        //  
        if VirtualProtect(@Thunk^._function, SizeOf(DWORD),
          PAGE_EXECUTE_READWRITE, Protect) then
        try
          //   ...
          //Thunk^._function := DWORD(NewProc);
          // ...   .
          InterlockedExchange(Integer(Thunk^._function), Integer(NewProc));
          Result := True;
        finally
          VirtualProtect(@Thunk^._function, SizeOf(DWORD), Protect, Protect);
          FlushInstructionCache(GetCurrentProcess, @Thunk^._function, SizeOf(DWORD));
        end;
      end
      else
        Inc(PAnsiChar(Thunk), SizeOf(TImageThunkData32));
    end;
    ImportEntry := Pointer(Integer(ImportEntry) + SizeOf(TImageImportDescriptor));
  end;
end;     

var
  OrigAddr: Pointer = nil;

function InterceptedMessageBoxA(Wnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
type
  TOrigMessageBoxA = function(Wnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
var
  S: AnsiString;
begin
  S := AnsiString('Function interepted. Original message: ' + lpText);
  Result := TOrigMessageBoxA(OrigAddr)(Wnd, PAnsiChar(S), lpCaption, uType);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OrigAddr := GetProcAddress(GetModuleHandle(user32), 'MessageBoxA');
  ReplaceIATEntry(OrigAddr, @InterceptedMessageBoxA);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MessageBoxA(0, 'Test Message', nil, 0);
end;

end.
