////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  "   API"
//  * Details   : http://alexander-bagel.blogspot.ru/2013/01/intercept.html
//  * Unit Name : uEAT
//  * Purpose   :     "   "
//  * Author    :  (Rouse_) 
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//


unit uEAT;

interface

uses
  Windows, Classes, Controls, Forms, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  DeclaredTypes;

function ReplaceEATEntry(const DllName: string; OldProc, NewProc: FARPROC): Boolean;
var
  ImageBase: Cardinal;
  DOSHeader: PImageDosHeader;
  NTHeader: PImageNtHeaders;
  ExportDirectory: PImageExportDirectory;
  pFuntionAddr: PDWORD;
  OrdinalCursor: PWORD;
  Ordinal, Protect: DWORD;
  FuntionAddr: FARPROC;
  I: Integer;
begin
  Result := False;
  if OldProc = nil then Exit;
  if NewProc = nil then Exit;
  ImageBase := GetModuleHandle(PChar(DllName));

  //    
  DOSHeader := PImageDosHeader(ImageBase);
  NTHeader := PImageNtHeaders(DWORD(DOSHeader) + DWORD(DOSHeader^._lfanew));
  ExportDirectory := PImageExportDirectory(DWORD(ImageBase) +
      DWORD(NTHeader^.OptionalHeader.DataDirectory[
      IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress));

  I := 1;
  //    
  OrdinalCursor := Pointer(ImageBase + DWORD(ExportDirectory^.AddressOfNameOrdinals));
  while I < Integer(ExportDirectory^.NumberOfNames) do
  begin

    //      
    Ordinal := OrdinalCursor^;

    //      
    FuntionAddr := Pointer(ImageBase + DWORD(ExportDirectory^.AddressOfFunctions));
    FuntionAddr := Pointer(ImageBase + PDWORD(DWORD(FuntionAddr) + Ordinal * 4)^);

    // ,    ?
    if FuntionAddr = OldProc then
    begin
      //  ,  ,     
      pFuntionAddr := PDWORD(ImageBase + DWORD(ExportDirectory^.AddressOfFunctions) + Ordinal * 4);
      //        hInstance 
      NewProc := Pointer(DWORD(NewProc) - ImageBase);

      //   
      if VirtualProtect(pFuntionAddr, SizeOf(DWORD),
        PAGE_EXECUTE_READWRITE, Protect) then
      try
        //   ...
        //pFuntionAddr^ := Integer(NewProc);
        // ...   .
        InterlockedExchange(Integer(PImageThunkData(pFuntionAddr)^._function), Integer(NewProc));
        Result := True;
      finally
        VirtualProtect(pFuntionAddr, SizeOf(DWORD), Protect, Protect);
        FlushInstructionCache(GetCurrentProcess, pFuntionAddr, SizeOf(DWORD));
      end;
      Break;
    end;

    Inc(I);
    Inc(OrdinalCursor);
  end;
end;

var
  OrigAddr: Pointer = nil;

function InterceptedMessageBoxA(Wnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
type
  TOrigMessageBoxA = function(Wnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
var
  S: AnsiString;
begin
  S := AnsiString('Function interepted. Original message: ' + lpText);
  Result := TOrigMessageBoxA(OrigAddr)(Wnd, PAnsiChar(S), lpCaption, uType);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OrigAddr := GetProcAddress(GetModuleHandle(user32), 'MessageBoxA');
  ReplaceEATEntry(user32, OrigAddr, @InterceptedMessageBoxA);
end;

procedure TForm1.Button1Click(Sender: TObject);
type
  TOrigMessageBoxA = function(Wnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
var
  OrigMessageBoxA: TOrigMessageBoxA;
begin
  @OrigMessageBoxA := GetProcAddress(GetModuleHandle(user32), 'MessageBoxA');
  OrigMessageBoxA(0, 'Test Message', nil, 0);
end;

end.
