////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  "   API"
//  * Details   : http://alexander-bagel.blogspot.ru/2013/01/intercept.html
//  * Unit Name : uNearJmpSplice
//  * Purpose   :     "    "
//  * Author    :  (Rouse_) 
//  * Version   : 1.0.1
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//

unit uNearJmpSplice;

interface

uses
  Windows, Classes, Controls, Forms, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  //      JMP NEAR OFFSET
  TNearJmpSpliceRec = packed record
    JmpOpcode: Byte;
    Offset: DWORD;
  end;

  //         JMP NEAR OFFSET
  TNearJmpSpliceData = packed record
    FuncAddr: FARPROC;
    OldData: TNearJmpSpliceRec;
    NewData: TNearJmpSpliceRec;
  end;

var
  NearJmpSpliceRec: TNearJmpSpliceData;

//        
procedure SpliceNearJmp(FuncAddr: Pointer; NewData: TNearJmpSpliceRec);
var
  OldProtect: DWORD;
begin
  VirtualProtect(FuncAddr, SizeOf(TNearJmpSpliceRec),
    PAGE_EXECUTE_READWRITE, OldProtect);
  try
    //   !!!
    Move(NewData, FuncAddr^, SizeOf(TNearJmpSpliceRec));
  finally
    VirtualProtect(FuncAddr, SizeOf(TNearJmpSpliceRec), OldProtect, OldProtect);
    FlushInstructionCache(GetCurrentProcess, FuncAddr, SizeOf(TNearJmpSpliceRec));
  end;
end;

//    MessageBoxA
function InterceptedMessageBoxA(Wnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
var
  S: AnsiString;
begin
  //  
  SpliceNearJmp(NearJmpSpliceRec.FuncAddr, NearJmpSpliceRec.OldData);
  try
    //   
    S := AnsiString('Function interepted. Original message: ' + lpText);
    Result := MessageBoxA(Wnd, PAnsiChar(S), lpCaption, uType);
  finally
    //  
    SpliceNearJmp(NearJmpSpliceRec.FuncAddr, NearJmpSpliceRec.NewData);
  end;
end;

procedure InitNearJmpSpliceRec;
begin
  //     
  NearJmpSpliceRec.FuncAddr :=
    GetProcAddress(GetModuleHandle(user32), 'MessageBoxA');
  //      ,    
  Move(NearJmpSpliceRec.FuncAddr^,
    NearJmpSpliceRec.OldData, SizeOf(TNearJmpSpliceRec));
  //   JMP NEAR
  NearJmpSpliceRec.NewData.JmpOpcode := $E9;
  //   
  NearJmpSpliceRec.NewData.Offset :=
    PAnsiChar(@InterceptedMessageBoxA) -
    PAnsiChar(NearJmpSpliceRec.FuncAddr) - SizeOf(TNearJmpSpliceRec);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //    
  InitNearJmpSpliceRec;
  //  MessageBoxA
  SpliceNearJmp(NearJmpSpliceRec.FuncAddr, NearJmpSpliceRec.NewData);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MessageBoxA(0, 'Test MessageBoxA Message', nil, 0);
end;

end.
